import {
  waitExamTaskCount,
  waitExamTaskNewCount,
  waitTaskReviewCount
} from "./api";
import { calcSum } from "@/plugins/utils";

const state = {
  waitTaskCount: 0
};

const mutations = {
  setNotDoneTaskCount(state, waitTaskCount) {
    state.waitTaskCount = waitTaskCount;
  }
};

const actions = {
  async updateWaitTaskCount({ commit }, userRoles = []) {
    // TODO:需要调整：/api/admin/work/exam/task/ready_count
    const apis = {
      QUESTION_TEACHER: [waitExamTaskCount],
      EXAM_TEACHER: [waitExamTaskNewCount, waitTaskReviewCount]
    };
    let countAll = [];
    Object.keys(apis).forEach(roleCode => {
      if (userRoles.includes(roleCode))
        countAll = [...countAll, ...apis[roleCode]];
    });
    const counts = await Promise.all(
      countAll.map(item => item())
    ).catch(() => {});

    const count = calcSum(counts || [0]);
    commit("setNotDoneTaskCount", count);
  }
};

export default {
  namespaced: true,
  state,
  mutations,
  actions
};
